#!/bin/sh -e
#This script makes xdtv recording in DVD format
# $Id: xdtv_makedvd.sh,v 1.3 2005/02/21 07:19:01 alainjj Exp $
#script under GNU General Public License (see COPYING)

#needs mplayer,mjpegtools,dvdauthor,toolame
#and the font arial.ttf in ~/.spumux/ for the subtitles

#CONFIG##################
ALANG=fr
SLANG=fr
STEREO=off #"on" or "off"
STD=pal #"pal" or "ntsc"
AUDIOBITRATE="" # default "-b 192"
VIDEOBITRATE="-q 10 -b 3000" # default "-q 8 -b 7500"
MOPTSSUP="-xvfmt yuv420"
###########################

DIR=/var/tmp/dvd$$
#DIR=/reserve2/xdtvdvd
SCRIPT=$0
mkdir -p $DIR
expr $SCRIPT : '/.*' > /dev/null || SCRIPT=`pwd`/$SCRIPT
cd $DIR
rm -f fifo.avi
mkfifo fifo.avi 

if [ "$STD" = "ntsc" ]; then
   FPS=29.97
   #WIDTH=720; HEIGHT=480
   WIDTH=352; HEIGHT=240
else
   FPS=25
   #WIDTH=720; HEIGHT=576
   WIDTH=352; HEIGHT=288
fi

xdtv -rec_width $WIDTH -rec_height $HEIGHT -rec_fps $FPS \
    -ybar 0 $OPTS  -rec_stereo $STEREO -rec_filename ./fifo.avi \
    -rec_vcodec uncompressed -rec_mp3 off -e record -nbufs 10 $MOPTSSUP &

rm -f stream.yuv audiodump.pcm
mkfifo stream.yuv audiodump.pcm

MOPTS="-noautosub -noaspect -noframedrop -vo yuv4mpeg -ao pcm -nowaveheader"
MOPTS="$MOPTS fifo.avi"
[ "$STEREO" = off ] && MOPTS="$MOPTS -channels 1"
mplayer -cache 30000 -ni -noframedrop $MOPTS &
PID1=$!

MP2OPTS="-v 0 -f 8 -a 2 $VIDEOBITRATE"
[ "$STD" = ntsc ] && MP2OPTS="$MP2OPTS -F 4" #non-roundness of ntsc fps...
mpeg2enc -o video.mpg $MP2OPTS < stream.yuv &
PID2=$!

TOOLAMEOPTS="$AUDIOBITRATE"
[ "$STEREO" = off ] && TOOLAMEOPTS="$TOOLAMEOPTS -m m"
(cat audiodump.pcm | toolame $TOOLAMEOPTS /dev/stdin audio$i.mpg) &
PID3=$!

wait $PID1
wait $PID2
wait $PID3

mplex -f 8 audio.mpg video.mpg -o dvd.mpg
rm -f stream.yuv audiodump.wav audio.mpg video.mpg

DVDAUTHOPTS="--video 4:3 -a $ALANG+16bps"
[ "$STEREO" = off ] && DVDAUTHOPTS="${DVDAUTHOPTS}+1ch"

FILE=dvd.mpg
#creation of the subtitles:
if [ -s fifo.sub ] && [ $(wc -l < fifo.sub) -gt 2 ]; then
   tr '\n' '' < fifo.sub | sed 's/\([0-9]\)/\1/g' | tr -s '' | 
    tr '' '\n' | sed -e 's/^ *\([^ ]\(.*[^ ]\)\?\).*$/\1/' > fifo2.sub
   cat > script <<EOF
      <subpictures>
          <stream>
              <textsub filename="fifo2.sub" characterset="ISO8859-1" horizontal-alignment="center" font="arial.ttf"
             />
           </stream>
       </subpictures>
EOF
   FILE="spumux script < $FILE |"
   DVDAUTHOPTS="$DVDAUTHOPTS -s $SLANG"
fi

#creation of dvd directory
rm -rf DVD
dvdauthor $DVDAUTHOPTS -o DVD -f "$FILE"
dvdauthor -T -o DVD

#saving the script, and the text subtitles in the iso image
mkdir -p DVD/data; cp -f $SCRIPT DVD/data
[ -f fifo2.sub ] && cp -f fifo.sub fifo2.sub DVD/data

echo "The directory $DIR/DVD is done."
echo "to test: mplayer -v -dvd-device $DIR/DVD dvd://1"
echo "to record on a disk: growisofs -Z /dev/dvdwriter -dvd-video $DIR"
#mkisofs -dvd-video DVD | cdrecord -v dev=ATA:1,0,0 -
echo "after this, DO NOT FORGET TO REMOVE $DIR"
